IPCS(1)

NAME
ipcs - report System V interprocess communication facilities status

SYNOPSIS
ipcs [-abcMmopQqSsTt]

DESCRIPTION
The ipcs program provides information on System V interprocess communication (IPC) facilities on the system.

The options are as follows:

-a  Show the maximum amount of information possible when displaying active message queues, shared memory segments, and semaphores. This is shorthand for specifying the -b, -c, -o, -p, and -t options.

-b  Show the maximum allowed sizes for active message queues, shared memory segments, and semaphores. The “maximum allowed size” is the maximum number of bytes in a message on a message queue, the size of a shared memory segment, or the number of semaphores in a set of semaphores.

-c  Show the creator's name and group for active message queues, shared memory segments, and semaphores.

-M  Display system information about shared memory.

-m  Display information about active shared memory segments.

-o  Show outstanding usage for active message queues, and shared memory segments. The “outstanding usage” is the number of messages in a message queue, or the number of processes attached to a shared memory segment.

-p  Show the PID information for active message queues, shared memory segments, and semaphores. The “PID information” is the last process to send a message to or receive a message from a message queue, the last process to attach to or detach a shared memory segment, or the process that created a semaphore.

-Q  Display system information about messages queues.

-q  Display information about active message queues.

-S  Display system information about semaphores.

-s  Display information about active semaphores.

-T  Display system information about message queues, shared memory segments, and semaphores. This is shorthand for specifying the -M, -Q, and -S options.

-t  Show access times for active message queues, shared memory segments, and semaphores. The access times is the time of the last control operation on an IPC object, the last send or receive of a message, the last attach or detach of a shared memory segment, or the last operation on a semaphore.

If none of the -M, -m, -Q, -q, -S, -s, or -T options are specified, information about all active IPC facilities is listed.

The output generated by ipcs if passed the -M, -Q, and -S options is self-explanatory. For the other options, the output consists of a series of columns depending on the facility in question as well as which of the various supported flags were given.

The meaning of each column as identified by the column heading is as follows:

T   The type of facility, identified as:

    m   shared memory segment
    s   semaphore
    q   message queue

ID  The identifier, suitable to be passed to, e.g., ipcrm(1).

KEY The key passed to, e.g., msgget(2), semget(2), or shmget(2); often created using ftok(3).

MODE
    A string of 11 characters representing the access mode and flags for the facility.

    On NetBSD, the first two characters are always ‘-’.

    The remaining 9 characters are similar to typical file permissions in that three characters each refer to owner-, group-, and other permissions of the facility entry with the following meaning:

    r   read permission
    w   write permission
    a   alter permission (the ability to change control information such as the owner or permissions)

OWNER
    The user name ( or, if no user name can be found, UID) of the owner of the facility entry.

GROUP
    The group name ( or, if no group name can be found, GID) of the group owner of the facility entry.

CREATOR
    The user name ( or, if no user name can be found, UID) of the creator of the facility entry.

CGROUP
    The group name ( or, if no group name can be found, GID) of the creator group owner of the facility entry.

Following this, the columns printed will differ for each of the facilities.

Times are displayed as if with strftime(3) ‘%k:%M:%S’ format (no leading zero for the hours value) in the time zone described by the TZ environment variable or /etc/localtime. If no time is available for the given event, the string ‘no-entry’ is used instead.

  Message Queues
CBYTES
    The total number of bytes left in the message queue.
QNUM
    The number of messages left in the message queue.
QBYTES
    The maximum number of bytes in the message queue.
LSPID
    The PID of the last process to send a message.
LRPID
    The PID of the last process to receive a message.
STIME
    The time of last msgsend(2).
RTIME
    The time of last msgrcv(2).
CTIME
    The time the message queue was created or last modified.

  Shared Memory
NATTCH
    The number of current attaches.
SEGSZ
    The size of the shared memory segment in bytes.
CPID
    The PID of the process that created the shared memory segment.
LPID
    The PID of the last shm operation.
ATIME
    The time of last shmat(2).
DTIME
    The time of last shmdt(2).
CTIME
    The time the shared memory segment was created or last modified.

  Semaphores
NSEMS
    The number of semaphores in the set.
OTIME
    The time of last semop(2).
CTIME
    The time the semaphore set was created or last modified.

CAVEATS
System data structures may change while ipcs is running; the output of ipcs is not guaranteed to be consistent.

SEE ALSO
ipcrm(1), msgctl(2), msgget(2), msgrcv(2), msgsnd(2), semctl(2), semget(2), semop(2), shmat(2), shmctl(2), shmdt(2), shmget(2), ftok(3)

AUTHORS
Thorsten Lockert <tholo@sigmasoft.com>

BUGS
The first two characters of the MODE are always set to ‘-’ on NetBSD. On other platforms, these characters may indicate additional state information about the given facility.